function [A,Sigma_A,C,dC_theta,Sigma_B_adj] = amat_lr_vlaar(B,Sigma_B,S,R,R_l,gamma,Psi,alpha,beta,epsilon,Z1,Z2,p,d,ind,Sigma_pi)

%
% for use only with the vlaar routine, when there are long run restrictions
%

r = size(alpha,2);
[n T] = size(epsilon);

if r<n;
   [C,Sigma_C,dC_theta,Sigma_theta] = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,ind,Sigma_pi);
else;
   [C,Sigma_C,dC_theta,Sigma_theta] = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,ind,Sigma_pi);
end;

%
% where dC_theta = dvec(C)/dvec(theta), where theta = [Psi alpha]
%

A = C*B;
b_i = kron(B',eye(n));
i_c = kron(eye(n),C);

%
% computing dvec(R)/dvec(C)'
%

dR_C = dr_c(R_l,n);

%
% computing dvec(S)/dvec(R)'
%

dS_R = ds_r(S,R);

%
% computing dvec(Omega)/dgamma'
%

dO_g = do_g(B,S);

%
% computing dvec(Omega)/vec(R)'
%

dO_R = do_r(B,R);

%
% computing dgamma/dvec(R)'
%

dg_R = dg_r(dO_R,dO_g);

%
% computing dvec(B)/dvec(R)'
%

dB_R = db_r(dS_R,dg_R,gamma,S,n);

%
% computing dvec(B)/dvec(theta)'
%

dB_theta = dB_R*dR_C*dC_theta;

%
% Computing dvec(A)/dvec(theta)'
% and       dvec(A)/dvec(B)'
%

dA_theta = (b_i*dC_theta)+(i_c*dB_theta);
dA_B = i_c;

%
% Computing the covariance matrix for A
%

Sigma_A = (dA_theta*Sigma_theta*dA_theta')+(dA_B*Sigma_B*dA_B');

%
% Computing the adjusted covariance matrix for B
%

Sigma_B_adj = (dB_theta*Sigma_theta*dB_theta')+Sigma_B;

%
% end of amat_lr_vlaar.m
%
