function status = autosavefigure(fig,filename)

curr_ini = find_inisettings;
my_external = 1;

if strcmp(curr_ini.graphicsfmt,'eps')==1;
   if appexist(curr_ini.epsviewer)==1;
      graphviewer = curr_ini.epsviewer;
   else;
      my_external = 0;
   end;
elseif strcmp(curr_ini.graphicsfmt,'ai')==1;
   if appexist(curr_ini.aiviewer)==1;
      graphviewer = curr_ini.aiviewer;
   else;
      my_external = 0;
   end;
else;
   if strcmp(curr_ini.graphicsfmt,'fig')==0;
      if appexist(curr_ini.bitmapviewer)==1;
         graphviewer = curr_ini.bitmapviewer;
      else;
         my_external = 0;
      end;
   end;
end;

if my_external==0;
   set(fig,'Visible','on');
   drawnow;
   status = 1;
   return;
end;

%
% we are ready to begin auto-saving a figure once we have a unique filename
%
k = 0;
i = 0;
while k<1;
   checkfile = [filename '-' num2str(i) '.' curr_ini.graphicsfmt];
   if fileexist(checkfile)==1;
      i = i+1;
   else;
      k = 1;
   end;
end;

filename = checkfile;

if iscompiled==1;
   %
   % valid formats
   %
   etx = '.fig .eps .ai .ps .bmp .hgl ';
   if isgs==1;
      etx = [etx '.png .jpg .jpeg .tif .tiff .pcx .pbm .pgm .ppm .pdf '];
   end;
   if ispstoedit==1;
      etx = [etx '.emf .wmf .tex '];
   end;
   %
   toolbar = get(fig,'UserData');
   set(toolbar.saveas,'UserData',1);
   thisext = strrep(getext(filename),' ','');
   if strcmp(thisext,'')==1;
      filename = [filename '.eps'];
   elseif strcmp(thisext,'.')==1;
      filename = [getname(filename) '.eps'];
   else;
      w = findstr([thisext ' '],etx);
      if isempty(w)==1;
         filename = [getname(filename) '.eps'];
      end;
   end;
   thisext = getext(filename);
   if strcmp(thisext,'.eps')==1;
      set(fig,'ResizeFcn','print_resize_legend_fcn');
      mstat = saveas_fcn(fig,filename,'epsc');
      set(fig,'ResizeFcn','toolbar_resize_fcn');
   elseif strcmp(thisext,'.ps')==1;
      set(fig,'ResizeFcn','print_resize_legend_fcn');
      mstat = saveas_fcn(fig,filename,'psc');
      set(fig,'ResizeFcn','toolbar_resize_fcn');
   elseif strcmp(thisext,'.fig')==1;
      set(toolbar.name,'UserData',filename);
      mstat = saveas_fcn(fig,filename);
   elseif strcmp(thisext,'')==1;
      txt = 'You didn''t select a graphics format. Unable to save graph.';
      about(txt,'information','No format...',120,400);
   else;
      set(fig,'ResizeFcn','print_resize_legend_fcn');
      if strcmp(curr_ini.graphicsfmt,'bmp')==1;
         set(fig,'Visible','on','WindowStyle','modal');
         drawnow;
      end;
      mstat = saveas_fcn(fig,filename);
      set(fig,'ResizeFcn','toolbar_resize_fcn');
      if strcmp(curr_ini.graphicsfmt,'bmp')==1;
         set(fig,'Visible','off','WindowStyle','normal');
         drawnow;
      end;
   end;
   set(toolbar.saveas,'UserData',0);
else;
   if (curr_ini.invert_hardcopy==0)&(strcmp(curr_ini.graphicsfmt,'fig')==0);
      all_axes = sort(findobj(fig,'Type','axes')');
      old_fig_color = get(fig,'Color');
      set(fig,'Color',get(all_axes(1,1),'Color'));
   end;
   if (curr_ini.invert_hardcopy==0)&(strcmp(curr_ini.graphicsfmt,'eps')==1);
      mstat = saveas_fcn(fig,filename,'epsc');
   elseif (curr_ini.invert_hardcopy==0)&(strcmp(curr_ini.graphicsfmt,'ps')==1);
      mstat = saveas_fcn(fig,filename,'psc');
   else;
      if strcmp(curr_ini.graphicsfmt,'bmp')==1;
         set(fig,'Visible','on','WindowStyle','modal');
         drawnow;
      end;
      mstat = saveas_fcn(fig,filename);
      if strcmp(curr_ini.graphicsfmt,'bmp')==1;
         set(fig,'Visible','off','WindowStyle','normal');
         drawnow;
      end;
   end;
   if (curr_ini.invert_hardcopy==0)&(strcmp(curr_ini.graphicsfmt,'fig')==0);
      set(fig,'Color',old_fig_color);
   end;
end;

close(fig);
drawnow;
status = mstat;

%
% end of autosavefigure.m
%
