function [theta,beta] = c_2d_restrict(Z0,Z1,Z2,restrict,beta,Theta,Rmat,rvec,p,pe,d,dcoint,q0,q1,modelsdir,modelfile,thisbij,row,col)

curr_ini = find_inisettings;

n = size(Theta,1);
r = size(beta,2);
T = size(Z0,2);

if curr_ini.convcrit<10;
   ch_convcrit = ['1.0e-00' num2str(curr_ini.convcrit)];
else;
   ch_convcrit = ['1.0e-0' num2str(curr_ini.convcrit)];
end;
ccrit = mystr2num(ch_convcrit);

Z3 = [];
alpha = [];
Psi = [];
if r>0;
   Z3 = beta'*Z1;
   alpha = Theta(:,size(Theta,2)-r+1:size(Theta,2));
end;
if isempty(Z2)==0;
   Z3 = [Z2;Z3];
   Psi = Theta(:,1:size(Theta,2)-r);
end;

theta = Theta;
epsilon = Z0-(Theta*Z3);
Omega = (1/T)*epsilon*epsilon';
oldOmega = Omega;

%
% evaluate all restrictions on Psi and alpha
%

if r<n;
   C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0);
else;
   C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0,[]);
end;
xi = xi_mat(C,Psi,alpha,p,pe,r,d,q1,q0);
f_vec = (Rmat*vec(C))-rvec;
%
% pick up any alpha restrictions
%
if restrict(1,1)==1;
   %
   % collect alpha restrictions
   %
   file = strcat(modelsdir,'G-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
   G = loaddata(file);
   [Rmat_alpha,rvec_alpha] = rmatrix(G,n,r);
   if isempty(Z2)==0;
      Rmat_alpha = [zeros(size(G,1),size(Z2,1)*n) Rmat_alpha];
   end;
   f_vec = [(Rmat_alpha*vec(Theta))-rvec_alpha;f_vec];
else;
   Rmat_alpha = [];
   rvec_alpha = [];
end;

%
% Determine the number of C restrictions
%

g_psi = [Rmat_alpha;Rmat*kron(xi',C)];
%
% check the rank of g_psi
%
if rank(g_psi)<size(g_psi,1);
   [red_rest,use_rest] = getdelvars(g_psi',[]);
   g_psi = g_psi(use_rest,:);
end;

num_c_rest = size(g_psi,1)-size(Rmat_alpha,1);
num_a_rest = size(Rmat_alpha,1);

if max(abs(f_vec))>ccrit;
   %
   % initialize beta restrictions if there are any
   %
   if curr_ini.reestbeta==1;
      %
      % Get the normalizing variables
      %
      file = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.norm');
      normvec = loaddata(file);
      I_mat = eye(size(beta,1));
      h = [];
      H = [];
      tot_free = 0;
      %
      % get restrictions on beta
      %
      for i=1:r;
         file = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.rest');
         if fileexist(file)==1;
            H_i = loaddata(file);
            %
            % impose additional restriction
            %
            if i==col;
               %
               % Recreate H_i such that new restriction is properly taken into account
               %
               normelem = normvec(i,1);
               normmatrix = [H_i(normelem,:);H_i(row,:)];
               if size(H_i,2)>size(normmatrix,1);
                  for k=1:(n+q1+dcoint);
                     if (k~=normelem)&(k~=row);
                        checkHk = [normmatrix;H_i(k,:)];
                        if rank(checkHk*checkHk')==size(checkHk,1);
                           normmatrix = checkHk;
                           if size(normmatrix,1)==size(H_i,2);
                              break;
                           end;
                        end;
                     end;
                  end;
               end;
               %
               % ensuring that H_i has [1 0 ... 0]
               % for normalizing parameter and
               % [0 1 0 ... 0] for restricted parameter
               %
               H_i = H_i/normmatrix;
               %
               % imposing the restriction
               %
               hj = thisbij*H_i(:,2);
               if size(H_i,2)>2;
                  H_i = [H_i(:,1)+hj H_i(:,3:size(H_i,2))];
               else;
                  H_i = H_i(:,1)+hj;
               end;
            end;
            %
            % determine which rows in H_i are linearly independend
            %
            H_fix = H_i(normvec(i),:);
            j = 1;
            while j<=size(H_i,1);
              if size(H_fix,1)<size(H_fix,2);
                 if j~=normvec(i);
                    H_test = [H_fix;H_i(j,:)];
                    if rank(H_test)==size(H_test,1);
                       H_fix = H_test;
                    end;
                 end;
                 j = j+1;
              else;
                 j = size(H_i,1)+1;
              end;
            end;
            H_i = H_i/H_fix;
            h_i = H_i(:,1);
            h = [h;h_i];
            if size(H_i,2)>1;
               H_i = H_i(:,2:size(H_i,2));
            else;
               H_i = [];
            end;
            H_struc.elem(i).H_i = H_i;
            H_struc.elem(i).tot_free = tot_free;
            tot_free = tot_free+size(H_i,2);
         end;
      end;
      %
      % now we construct H from the above info
      %
      for i=1:r;
         if isempty(H_struc.elem(i).H_i)==1;
            H = [H;zeros(size(beta,1),tot_free)];
         else;
            H_i = H_struc.elem(i).H_i;
            my_free = H_struc.elem(i).tot_free;
            if my_free>0;
               H_first = zeros(size(beta,1),my_free);
            else;
               H_first = [];
            end;
            if tot_free-(my_free+size(H_i,2))>0;
               H_last = zeros(size(beta,1),tot_free-(my_free+size(H_i,2)));
            else;
               H_last = [];
            end;
            H = [H;[H_first H_i H_last]];
         end;
      end;
      %
      % matrices needed to compute the gradient wrt beta
      %
      M_10 = (1/T)*Z1*Z0';
      M_11 = (1/T)*Z1*Z1';
      if isempty(Z2)==0;
         M_12 = (1/T)*Z1*Z2';
         M_22 = (1/T)*Z2*Z2';
      else;
         M_12 = [];
         M_22 = [];
      end;
   end;
   %
   % we need to estimate C under restrictions
   %
   max_val = max(abs(f_vec));
   it = 0;
   psi = vec(Theta);
   %
   while (max_val>ccrit)&(it<curr_ini.maxit);
      it = it+1;
      ZZ_inv = (Z3*Z3')\eye(size(Z3,1));
      %
      it_psi = 0;
      while (max_val>ccrit)&(it_psi<curr_ini.maxit);
         it_psi = it_psi+1;
         %
         % estimate Psi and alpha under restrictions
         %
         g_psi = [Rmat_alpha;Rmat*kron(xi',C)];
         %
         % check the rank of g_psi
         %
         if rank(g_psi)<size(g_psi,1);
            [red_rest,use_rest] = getdelvars(g_psi',[]);
            g_psi = g_psi(use_rest,:);
            f_vec = f_vec(use_rest,1);
         end;
         %
         psi_adj_part1 = kron(ZZ_inv,Omega)*g_psi';
         psi_adj_part2 = (g_psi*psi_adj_part1)\eye(size(g_psi,1));
         psi_adj = psi_adj_part1*psi_adj_part2*f_vec;
         %
         psi = psi-psi_adj;
         %
         % reconstruct matrices
         %
         theta = vecinv(psi,n);
         if r>0;
            alpha = theta(:,size(theta,2)-r+1:size(theta,2));
         else;
            alpha = [];
         end;
         if isempty(Z2)==0;
            Psi = theta(:,1:size(theta,2)-r);
         else;
            Psi = [];
         end;
         epsilon = Z0-(theta*Z3);
         Omega = (1/T)*epsilon*epsilon';
         if r<n;
            C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0);
         else;
            C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0,[]);
         end;
         xi = xi_mat(C,Psi,alpha,p,pe,r,d,q1,q0);
         f_vec = (Rmat*vec(C))-rvec;
         if isempty(Rmat_alpha)==0;
            f_vec = [(Rmat_alpha*vec(theta))-rvec_alpha;f_vec];
         end;
         max_val = max(abs(f_vec));
      end;
      %
      % update beta
      %
      if curr_ini.reestbeta==1;
         if rank(Omega,eps)<size(Omega,1);
            if rank(oldOmega,eps)<size(oldOmega,1);
               inv_Omega = eye(n);
            else;
               inv_Omega = oldOmega\eye(n);
            end;
         else;
            inv_Omega = Omega\eye(n);
         end;
         %
         m_1 = H'*kron(alpha'*inv_Omega*alpha,M_11)*H;
         m_2 = H'*kron(alpha'*inv_Omega,I_mat);
         if isempty(M_12)==0;
            c_1 = vec((M_10-(M_12*Psi')));
         else;
            c_1 = vec(M_10);
         end;
         c_2 = kron(alpha,M_11)*h;
         phi = m_1\(m_2*(c_1-c_2));
         v_beta = h+(H*phi);
         beta = vecinv(v_beta,size(beta,1));
         %
         % evaluate everything under the new beta
         %
         Z3 = [];
         if r>0;
            Z3 = beta'*Z1;
         end;
         if isempty(Z2)==0;
            Z3 = [Z2;Z3];
         end;
         %
         epsilon = Z0-(theta*Z3);
         Omega = (1/T)*epsilon*epsilon';
         %
         if r<n;
            C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0);
         else;
            C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0,[]);
         end;
         xi = xi_mat(C,Psi,alpha,p,pe,r,d,q1,q0);
         f_vec = (Rmat*vec(C))-rvec;
         if isempty(Rmat_alpha)==0;
            f_vec = [(Rmat_alpha*vec(theta))-rvec_alpha;f_vec];
         end;
         %
         max_val = max(abs(f_vec));
      end;
   end;
end;

%
% end of c_2d_restrict.m
%
