function [tests,deg_free,pvals,params] = coint_exclusion(S_00,S_01,S_10,S_11,M_02,M_22,M_12,Z0,Z1,Z2,epsilon,r,q1,dcoint,df,sscorrect)

[n T] = size(epsilon);
tests = zeros(n+q1+dcoint,1);
deg_free = zeros(n+q1+dcoint,1+sscorrect);
pvals = zeros(n+q1+dcoint,1);
%
% compute log-likelihood value under the alternative
%
lnL_alt = loglike(epsilon);
%
% restriction help files
%
H_base = eye(n+q1+dcoint);
h_cols = (1:1:n+q1+dcoint);
for i=1:n+q1+dcoint;
   hi_cols = h_cols(h_cols~=i);
   H = H_base(:,hi_cols);
   %
   % step 1: H'*S_11*H
   %
   HS_11 = H'*S_11*H;
   HS_symm = symm(HS_11);
   HS_adj = inverse(HS_symm)*H'*S_10*inverse(S_00)*S_01*H*inverse(HS_symm);
   %
   % Step 2: solve the eigenvalue problem
   %
   [U,lambda] = eig(HS_adj);
   %
   lambda = diag(lambda,0);
   [lambda2,AscInd] = sort(abs(lambda));
   %
   nr = size(AscInd,1);
   DescInd = zeros(nr,1);
   for j=1:nr;
      DescInd(j)=AscInd(nr+1-j);
   end;
   %
   % Resort eigenvalues and eigenvectors
   % in descending order
   %
   lambda = abs(lambda(DescInd));
   U = U(:,DescInd);
   %
   % Renormalize U such that V'H'S_11HV=I
   %
   V = inverse(HS_symm)*U;
   %
   psi = V(:,1:r);
   beta = H*psi;
   %
   % now we compute the remaining parameters
   %
   alpha = (S_01*beta)*inverse(beta'*S_11*beta);
   if isempty(Z2)==0;
      Psi = (M_02*inverse(M_22))-(alpha*beta'*M_12*inverse(M_22));
      epsilon_n = Z0-(alpha*beta'*Z1)-(Psi*Z2);
   else;
      epsilon_n = Z0-(alpha*beta'*Z1);
   end;
   lnL_new = loglike(epsilon_n);
   LR = 2*(lnL_alt-lnL_new);
   if nargout>3;
      params.variable(i).beta = beta;
      params.variable(i).alpha = alpha;
      params.variable(i).Psi = Psi;
      params.variable(i).epsilon = epsilon_n;
      params.variable(i).Omega = (1/T)*epsilon_n*epsilon_n';
   end;
   %
   %
   %
   deg_free(i,1) = r;
   if sscorrect==0;
      pvals(i,1) = 1-chis_cdf(LR,r);
   else;
      dfc = round(((n+q1+dcoint-r)*r)/n);
      df_adj = round(((n+q1+dcoint-r-1)*r)/n);
      df_adj = df-dfc+df_adj;
      deg_free(i,2) = T-df_adj-1;
      LR = ((T-df_adj-1)/((T-1)*r))*LR;
      pvals(i,1) = 1-fdis_cdf(LR,r,deg_free(i,2));;
   end;
   tests(i,1) = LR;
end;

%
% end of coint_exclusion.m
%
