%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab function for creating the commutation          %
%          matrix for vectorizations of an mxn matrix            %
%                                                                %
%          Function: commutation                                 %
%                                                                %
%          Input:                                                %
%                        m: integer (rows)                       %
%                        n: integer (columns)                    %
%                                                                %
%          Output:                                               %
%          		           Kmn: mnxmn 0-1 matrix                   %
%          		               for transforming vec(A), for        %
%                            an mxn matrix A, into vec(A'),      %
%                            i.e., vec(A') = Kmn*vec(A)          %
%                                                                %
%          This version:        November 18, 2004                %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2004          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Kmn = commutation(m,n)

Kmn = zeros(m*n,m*n);

i = 1;
while i<=m;
   j = 1;
   while j<=n;
      Kmn(j+n*(i-1),i+m*(j-1)) = 1;
      j = j+1;
   end;
   i = i+1;
end;
