%
%
% create states matrices and save data to file
%

function create_states_mat(num)

if nargin==0;
   num = 15;
end;

if ischar(num)==1;
   num = mystr2num(num);
end;

for i=1:num;
   file = [pwd '\data\states-' num2str(i,'%0.0f') '.mat'];
   if fileexist(file)==0;
      %
      % show a wait dialog
      %
      text = strvcat(['Determining all of combinations of ' num2str(i,'%0.0f') ' states to test for local identification...'],'Please hold!');
      disp(text);
      states = var_comb(i);
      text = strvcat(' ','Saving data to file...','Please hold!');
      disp(text);
      %
      % save to disk
      %
      save(file,'states');
   end;
   %
   % now we create partial matrices
   %
   m_states = load(file);
   states = [zeros(1,i);m_states.states];
   clear('m_states');
   %
   file = [pwd '\data\states-' num2str(i,'%0.0f') '.' num2str(i,'%0.0f') '.mat'];
   if fileexist(file)==0;
      save(file,'states');
   end;
   %
   f_states = states;
   clear('states');
   %
   if i>1;
      for j=1:i-1;
         file = [pwd '\data\states-' num2str(i,'%0.0f') '.' num2str(j,'%0.0f') '.mat'];
         if fileexist(file)==0;
            disp(['Case (i,j)=(' int2str(i) ',' int2str(j) ')']);
            if j<i-1;
               states = [];
               for k=1:size(f_states,1);
                  stat_r = f_states(k,:);
                  stat_r = stat_r(stat_r~=0);
                  if size(stat_r,2)<=j;
                     states = [states;f_states(k,:)];
                  end;
               end;
            else;
               states = f_states(1:size(f_states,1)-1,:);
            end;
            save(file,'states');
         end;
      end;
   end;
   clear('f_states');
end;

%
% end of create_states_mat.m
%
