function model_info = getmodelinfo(cm,add_evalue)

if nargin==1;
   add_evalue = 0;
end;

model_info.header = 'Endogenous variables:';
model_info.info = cm.evars;
%
% trim text if necessary
%
if strcmp(cm.restvec,'')==1;
   if size(cm.deter,2)>=60;
      thisdeter = cm.deter(1,1:60);
      for i=0:58;
         if strcmp(thisdeter(1,60-i),' ')==1;
            thisdeter = thisdeter(1,1:(59-i));
            break;
         end;
      end;
      thisdeter = [thisdeter '...'];
   else;
      thisdeter = cm.deter;
   end;
else;
   thisdeter = strtrim([strtrim(cm.deter) ' ' cm.restvec]);
   if size(thisdeter,2)>=60;
      thisdeter = thisdeter(1,1:60);
      for i=0:58;
         if strcmp(thisdeter(1,60-i),' ')==1;
            thisdeter = thisdeter(1,1:(59-i));
            break;
         end;
      end;
      thisdeter = [thisdeter '...'];
   end;
end;
model_info.header = strvcat(model_info.header,'Deterministic variables:');
model_info.info = strvcat(model_info.info,thisdeter);
if cm.q1>0;
   thisxvars1 = cm.xvars1;
   if size(thisxvars1,2)>=60;
      thisxvars1 = thisxvars1(1,1:60);
      for i=0:58;
         if strcmp(thisxvars1(1,60-i),' ')==1;
            thisxvars1 = thisxvars1(1,1:(59-i));
            break;
         end;
      end;
      thisxvars1 = [thisxvars1 '...'];
   end;
else;
   thisxvars1 = 'None';
end;
model_info.header = strvcat(model_info.header,'Exogenous I(1) variables:');
model_info.info = strvcat(model_info.info,thisxvars1);
if cm.q0>0;
   thisxvars0 = cm.xvars0;
   if size(thisxvars0,2)>=60;
      thisxvars0 = thisxvars0(1,1:60);
      for i=0:58;
         if strcmp(thisxvars0(1,60-i),' ')==1;
            thisxvars0 = thisxvars0(1,1:(59-i));
            break;
         end;
      end;
      thisxvars0 = [thisxvars0 '...'];
   end;
else;
   thisxvars0 = 'None';
end;
model_info.header = strvcat(model_info.header,'Exogenous I(0) variables:');
model_info.info = strvcat(model_info.info,thisxvars0);
add_lag = '';
if (cm.q0+cm.q1>0)&(cm.p~=cm.pe);
   add_lag = [' for endogenous and ' num2str(cm.pe) ' for exogenous variables'];
end;
model_info.header = strvcat(model_info.header,'Number of lags:','Number of observations:','Degrees of freedom:','Maximized log-likelihood:');
model_info.info = strvcat(model_info.info,[num2str(cm.p,'%0.0f') add_lag],num2str(cm.T,'%0.0f'),' ',' ');
if add_evalue==1;
   model_info.header = strvcat(model_info.header,'Max non-unit eigenvalue:');
   model_info.info = strvcat(model_info.info,' ');
end;

%
% end of getmodelinfo.m
%
