function i_phi = info_phi(B,Omega,Z1,Z2,beta,S,r,normval)

%
% if we set normval to 1, then ZZ is divided by T and so is b_b
%

if nargin<8;
   normval = 0;
end;

n = size(B,1);
%Omega = B*B';
Omega_inv = Omega\eye(n);

Z = [];
if r>0;
   Z = beta'*Z1;
end;
Z = [Z2;Z];
T = size(Z,2);

if normval==1;
   ZZ = (1/T)*Z*Z';
else;
   ZZ = Z*Z';
end;
ZZ_Omega = kron(ZZ,Omega_inv);

Nn = ncommutation(n);
B_inv = B\eye(n);
b_eye = kron(eye(n),B_inv);
if normval==1;
   b_b = 2*b_eye'*Nn*b_eye;
else;
   b_b = 2*T*b_eye'*Nn*b_eye;
end;
k1 = size(ZZ_Omega,1);
k2 = size(b_b,1);
info_inv_theta = [[ZZ_Omega zeros(k1,k2)];[zeros(k2,k1) b_b]];

i_phi = S'*info_inv_theta*S;

%
% end of info_phi.m
%
