function print_archtest(tm,curr_ini,epsilon,beta_df,alpha_df,my_df)

fout = fopen(tm.outputfile,'at');
%
[results,dfmat] = arch(epsilon,tm.freq,tm.T-my_df);
%
% and now the multivariate tests
%
[m_res,m_df] = march(epsilon,tm.T-my_df,curr_ini.rest_march,curr_ini.sscorrect);
%
if curr_ini.texoutputformat>=2;
   fprintf(fout,['\\subsection*{ARCH tests}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
   %
   % first the multivariate test
   %
   if isempty(m_res)==0;
      fprintf(fout,'\\header{Multivariate ARCH Test}\n\n');
      fprintf(fout,'\\begin{tabular}{rr}\n');
      if curr_ini.rest_march==1;
         fprintf(fout,'\\multicolumn{2}{c}{(MARCH model has diagonal lag matrix)} \\\\\n');
      end;
      if curr_ini.sscorrect==0;
         fprintf(fout,['LM(%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],m_df(1,1),m_res(1,1),m_res(1,2));
      else;
         fprintf(fout,['F(%0.0f,%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],m_df(1,1),m_df(1,2),m_res(1,1),m_res(1,2));
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      fprintf(fout,'\\ruler\n\n%%------------------------------------------------------------------------------\n\n');
   end;
   %
   if curr_ini.sscorrect==0;
      fprintf(fout,['\\header{LM tests for 1st order ARCH with ' num2str(dfmat(1,1)) ' deg. freedom:}\n\n']);
   else;
      fprintf(fout,['\\header{F-tests based on LM for 1st order ARCH with (' num2str(dfmat(1,1)) ',' num2str(dfmat(1,2)) ') deg. freedom:}\n\n']);
   end;
   fprintf(fout,'\\begin{tabular}{rrr}\n');
   fprintf(fout,'Equation & Test & $p$-value \\\\\n');
   for i=1:tm.n;
      if strcmp(tm.freq,'')==1;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' '%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results(i,1),results(i,2));
      else;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' '%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results(i,1),results(i,3));
      end;
   end;
   fprintf(fout,'\\end{tabular}\n\n');
   if strcmp(tm.freq,'')==0;
      mystr = '4';
      if strcmp(tm.freq,'m')==1;
         mystr = '12';
      end;
      if curr_ini.sscorrect==0;
         fprintf(fout,['\\header{LM tests for 1st-' mystr 'th order ARCH with ' num2str(dfmat(1,2)) ' deg. freedom:}\n\n']);
      else;
         fprintf(fout,['\\header{F-tests based on LM for 1st-' mystr 'th order ARCH with (' num2str(dfmat(1,3)) ',' num2str(dfmat(1,4)) ') deg. freedom:}\n\n']);
      end;
      fprintf(fout,'\\begin{tabular}{rrr}\n');
      fprintf(fout,'Equation & Test & $p$-value \\\\\n');
      for i=1:tm.n;
         fprintf(fout,[txt2ltxmath(strtrim(tm.myvars(i,:)),'\') ' & ' '%0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results(i,2),results(i,4));
      end;
      fprintf(fout,'\\end{tabular}\n\n');
   end;
   fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
else;
   fprintf(fout,['ARCH TESTS\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
   %
   % first the multivariate test
   %
   if isempty(m_res)==0;
      fprintf(fout,'Multivariate ARCH Test \n~~~~~~~~~~~~~~~~~~~~~~ \n\n');
      if curr_ini.rest_march==1;
         fprintf(fout,'  (MARCH model has diagonal lag matrix) \n\n');
      end;
      if curr_ini.sscorrect==0;
         fprintf(fout,['LM(%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \np-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n\n'],m_df(1,1),m_res(1,1),m_res(1,2));
      else;
         fprintf(fout,['F(%0.0f,%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \np-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n\n'],m_df(1,1),m_df(1,2),m_res(1,1),m_res(1,2));
      end;
      fprintf(fout,'------------------------------------------------------------------------------\n\n');
   end;
   %
   if curr_ini.sscorrect==0;
      fprintf(fout,['LM tests for 1st order ARCH with ' num2str(dfmat(1,1)) ' deg. freedom:\n']);
   else;
      fprintf(fout,['F-tests based on LM for 1st order ARCH with (' num2str(dfmat(1,1)) ',' num2str(dfmat(1,2)) ') deg. freedom:\n']);
   end;
   fprintf(fout,'\nEquation       Test       p-value\n\n');
   for i=1:tm.n;
      if strcmp(tm.freq,'')==1;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results(i,1),results(i,2));
      else;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results(i,1),results(i,3));
      end;
   end;
   fprintf(fout,'\n');
   if strcmp(tm.freq,'')==0;
      mystr = '4';
      if strcmp(tm.freq,'m')==1;
         mystr = '12';
      end;
      if curr_ini.sscorrect==0;
         fprintf(fout,['LM tests for 1st-' mystr 'th order ARCH with ' num2str(dfmat(1,2)) ' deg. freedom:\n']);
      else;
         fprintf(fout,['F-tests based on LM for 1st-' mystr 'th order ARCH with (' num2str(dfmat(1,3)) ',' num2str(dfmat(1,4)) ') deg. freedom:\n']);
      end;
      fprintf(fout,'\n');
      for i=1:tm.n;
         fprintf(fout,[tm.myvars(i,:) tm.mv2add '%' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],results(i,2),results(i,4));
      end;
      fprintf(fout,'\n');
   end;
   fprintf(fout,'===============================================================================\n\n');
end;
fclose(fout);

%
% end of print_archtest.m
%
