function print_mgctest(tm,curr_ini,beta,alpha,Psi,epsilon,Sigma_theta,beta_df,alpha_df,a_ind,c_ind)

%
% open the output file for adding text to it
%
fout = fopen(tm.outputfile,'at');
if curr_ini.texoutputformat>=2;
   fprintf(fout,['\\subsection*{Multi-Step Granger causality tests}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
   fprintf(fout,'\\header{Wald-type test statistic}\n\n');
else;
   fprintf(fout,['MULTI-STEP GRANGER CAUSALITY TESTS\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
   fprintf(fout,'  Wald-type test statistic\n  ~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
end;

for i=1:tm.n;
   for j=1:tm.n;
      if isequal(i,j)==0;
         [tests,df,pvals] = waldmgctest(Psi,alpha,beta,tm.p,tm.pe,epsilon,tm.Z1,tm.Z2,tm.q1,tm.q0,tm.d,tm.T-tm.df,a_ind,Sigma_theta,c_ind,curr_ini.sscorrect,curr_ini.noise_parm,i,j);
         %
         %
         if curr_ini.texoutputformat>=2;
            %
            % LaTeX output
            %
            fprintf(fout,'\\begin{tabular}{rrrr}\n');
            fprintf(fout,'$H_0$: & \\multicolumn{3}{l}{%s is Granger noncausal for %s} \\\\\n',txt2ltxmath(strtrim(tm.myvars(i,:))),txt2ltxmath(strtrim(tm.myvars(j,:))));
            fprintf(fout,'$H_A$: & \\multicolumn{3}{l}{%s is Granger causal for %s} \\\\[2mm]\n',txt2ltxmath(strtrim(tm.myvars(i,:))),txt2ltxmath(strtrim(tm.myvars(j,:))));
            %
            if curr_ini.sscorrect==0;
               fprintf(fout,'horizon & W & df & $p$-value \\\\\n');
               for k=1:size(tests,1);
                  if isequal(tests(k,1),0)==0;
                     if k>1;
                        fprintf(fout,['1-%0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],k,tests(k,1),df(k,1),pvals(k,1));
                     else;
                        fprintf(fout,['  %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],k,tests(k,1),df(k,1),pvals(k,1));
                     end;
                  else;
                     if k>1;
                        fprintf(fout,'1-%0.0f & \\multicolumn{3}{l}{not computed} \\\\\n',k);
                     else;
                        fprintf(fout,'  %0.0f & \\multicolumn{3}{l}{not computed} \\\\\n',k);
                     end;
                  end;
               end;
            else;
               fprintf(fout,'horizon & F & df & $p$-value \\\\\n');
               for k=1:size(tests,1);
                  if isequal(tests(k,1),0)==0;
                     if k>1;
                        fprintf(fout,['1-%0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],k,tests(k,1),df(k,1),df(k,2),pvals(k,1));
                     else;
                        fprintf(fout,['  %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],k,tests(k,1),df(k,1),df(k,2),pvals(k,1));
                     end;
                  else;
                     if k>1;
                        fprintf(fout,'1-%0.0f & \\multicolumn{3}{l}{not computed} \\\\\n',k);
                     else;
                        fprintf(fout,'  %0.0f & \\multicolumn{3}{l}{not computed} \\\\\n',k);
                     end;
                  end;
               end;
            end;
            %
            fprintf(fout,'\\end{tabular}\n\n');
            if (i<tm.n)|((i==tm.n)&(j<tm.n-1));
               fprintf(fout,'\\halfruler\n\n%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
            else;
               fprintf(fout,'\\vspace*{3mm}\n\n\\begin{tabular}{lp{100mm}}\n \\textbf{NOTE:} & Horizon 1-%0.0f implies infinite-step Granger noncausality (causality)\nunder the null (alternative) hypothesis. Furthermore, horizon 1 is\nidentical to the usual Granger causality test. \\\\\n\\end{tabular}\n\n',size(tests,1));
%               fprintf(fout,'\nNOTE: Horizon 1-%0.0f implies infinite-step Granger noncausality\n      (causality) under the null (alternative) hypothesis.\n      Furthermore, horizon 1 is identical to the usual Granger\n      causality test.\n',size(tests,1));
               fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
            end;
         else;
            %
            % formatted plain text output
            %
            fprintf(fout,'Null Hypothesis:        %s is h-step Granger noncausal for %s \n',strtrim(tm.myvars(i,:)),strtrim(tm.myvars(j,:)));
            fprintf(fout,'Alternative Hypothesis: %s is h-step Granger causal for %s \n\n',strtrim(tm.myvars(i,:)),strtrim(tm.myvars(j,:)));
            %
            if curr_ini.sscorrect==0;
               fprintf(fout,'horizon        W        df         p-value\n\n');
               for k=1:size(tests,1);
                  if isequal(tests(k,1),0)==0;
                     if k>1;
                        fprintf(fout,['  1-%0.0f      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %2.0f        %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],k,tests(k,1),df(k,1),pvals(k,1));
                     else;
                        fprintf(fout,['    %0.0f      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     %2.0f        %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],k,tests(k,1),df(k,1),pvals(k,1));
                     end;
                  else;
                     if k>1;
                        fprintf(fout,'  1-%0.0f      not computed\n',k);
                     else;
                        fprintf(fout,'    %0.0f      not computed\n',k);
                     end;
                  end;
               end;
            else;
               fprintf(fout,'horizon        F          df          p-value\n\n');
               for k=1:size(tests,1);
                  if isequal(tests(k,1),0)==0;
                     if k>1;
                        fprintf(fout,['  1-%0.0f      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     (%0.0f,%0.0f)        %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],k,tests(k,1),df(k,1),df(k,2),pvals(k,1));
                     else;
                        fprintf(fout,['    %0.0f      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f     (%0.0f,%0.0f)        %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],k,tests(k,1),df(k,1),df(k,2),pvals(k,1));
                     end;
                  else;
                     if k>1;
                        fprintf(fout,'  1-%0.0f      not computed\n',k);
                     else;
                        fprintf(fout,'    %0.0f      not computed\n',k);
                     end;
                  end;
               end;
            end;
            %
            if (i<tm.n)|((i==tm.n)&(j<tm.n-1));
               fprintf(fout,'\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
            else;
               fprintf(fout,'\nNOTE: Horizon 1-%0.0f implies infinite-step Granger noncausality\n      (causality) under the null (alternative) hypothesis.\n      Furthermore, horizon 1 is identical to the usual Granger\n      causality test.\n',size(tests,1));
               fprintf(fout,'\n===============================================================================\n\n');
            end;
         end;
      end;
   end;
end;

fclose(fout);

%
% end of print_mgctest.m
%
