function color = DefaultPrtColor
%DEFAULTPRTCOLOR Retrieve  color mode for the default printer (1=color; 0=mono)

%   Copyright (c) 1984-98 by The MathWorks, Inc.
%   $Revision: 1.1 $  $Date: 1998/10/20 21:13:25 $

% Retrieve default printer device
[pcmd, in_dev] = printopt;  
dev = in_dev(3:end);

% For windows drivers, default color mode is based on default printer
if strcmp(computer, 'PCWIN') & strncmp(dev,'win',3)
	color = system_dependent('getprintercolor');
% For all other drivers, determine color mode from printopt value
else
	[ options, devices, extensions, classes, colorDevs, ...
           destinations] = tables(printjob);
	color = 'C' == colorDevs{find(strcmp(dev,devices))};
	
end

pagesetup_name = get(gcf,'Name');
fig_name = strrep(pagesetup_name,'Page Setup - ','');
fig_name = strrep(fig_name,'Print Preview - ','');
this_fig = sort(findobj('Type','figure','Name',fig_name)');

if isempty(this_fig)==0;
   if ishandle(this_fig(1,1))==1;
      if strcmp(get(this_fig(1,1),'InvertHardcopy'),'on')==1;
         color = 0;
      else;
         color = 1;
      end;
   end;
end;

%
% end of DefaultPrtColor.m
%
