function [S_00,S_01,S_10,S_11,M_02,M_22,M_12] = rrr_mat(Z0,Z1,Z2)

[n T] = size(Z0);

%
% Compute product moment matrices M_ij
%

M_00 = (1/T)*Z0*Z0';
M_01 = (1/T)*Z0*Z1';
if isempty(Z2)==0;
   M_02 = (1/T)*Z0*Z2';
   M_12 = (1/T)*Z1*Z2';
   M_22 = (1/T)*Z2*Z2';
else;
   M_02 = [];
   M_12 = [];
   M_22 = [];
end;
M_10 = M_01';
M_20 = M_02';
M_11 = (1/T)*Z1*Z1';
M_21 = M_12';

%
% Compute product moment matrice S_ij
%

if isempty(Z2)==0;
   S_00 = M_00-(M_02/M_22)*M_20;
   S_11 = M_11-(M_12/M_22)*M_21;
   S_01 = M_01-(M_02/M_22)*M_21;
   S_10 = M_10-(M_12/M_22)*M_20;
else;
   S_00 = M_00;
   S_11 = M_11;
   S_01 = M_01;
   S_10 = M_10;
end;

%
% end of rrr_mat.m
%
